<template>
  <div>
    <h1 class="text-2xl text-green-500">{{ title }}</h1>
    <table class="table-auto border-separate border border-green-800">
      <tr
        class="
          text-md
          font-semibold
          tracking-wide
          text-left text-gray-900
          bg-gray-100
          uppercase
          border-b border-gray-600
        "
      >
        <th>Nombre</th>
        <th>Hora de entrada</th>
        <th>Hora de salida</th>
        <th>Descanso</th>
        <th>Horas trabajadas</th>
        <th>Cargo Asociado</th>
        <th>Sucursales asociadas</th>
      </tr>
      <tr
        v-for="turnTemplate in turnTemplatesList"
        :key="turnTemplate.id"
        class="text-gray-700"
      >
        <td class="px-4 py-3 border">
          {{ turnTemplate.name }}
        </td>
        <td class="px-4 py-3 border">
          {{ turnTemplate.checkIn }}
        </td>
        <td class="px-4 py-3 border">
          {{ turnTemplate.checkOut }}
        </td>
        <td class="px-4 py-3 border">{{ turnTemplate.breakTime }}</td>
        <td class="px-4 py-3 border">{{ turnTemplate.id }}</td>
        <td class="px-4 py-3 border">{{ turnTemplate.position }}</td>
        <td class="px-4 py-3 border">{{ turnTemplate.locations }}</td>
      </tr>
    </table>
    <ul v-if="errors && errors.length">
      <li v-for="error of errors" :key="error.message">
        {{ error.message }}
      </li>
    </ul>
  </div>
</template>

<script>
import getTurnTemplates from '../helpers/getTurnTemplates.js';
import getPositions from '../helpers/getPositions.js';
import getLocations from '../helpers/getLocations.js';
export default {
  data() {
    return {
      title: 'Plantillas',
      turnTemplatesList: [],
      errors: [],
    };
  },
  async created() {
    try {
      this.turnTemplatesList = await getTurnTemplates();
      this.positionsList = await getPositions();
      this.locationsList = await getLocations();
      const positionList = this.positionsList;
      const locationList = this.locationsList;
      this.turnTemplatesList.forEach(async function (turnTemplate) {
        // positions
        const position = positionList.find(
          (pos) => turnTemplate.positionId == pos.id
        );
        if (position != undefined) {
          turnTemplate.position = position.name;
        } else {
          turnTemplate.position = '';
        }
        // sucursales asociadas
        turnTemplate.locations = '';

        locationList.forEach(async function (location) {
          if (turnTemplate.locationId != undefined) {
            if (turnTemplate.locationId.includes(location.id)) {
              turnTemplate.locations += ' ' + location.name;
            }
          }
        });
      });
    } catch (e) {
      this.errors.push(e);
    }
  },
};
</script>
